package main

/*
	this parses the command line arguements
*/

var argv args

type args struct {
	Trim    bool `arg:"--trim"      default:"true"     help:"trim entries from go.sum"`
	Verbose bool `arg:"--verbose"                      help:"show more"`
	Restore bool `arg:"--restore"                      help:"only restore from go/pkg/mod/"`
	Force   bool `arg:"--force"                        help:"remove things and redo them no matter what"`
	Strict  bool `arg:"--strict"                       help:"never make go.* files unless everything is perfect"`
	Purge   bool `arg:"--purge"                        help:"purge all the git notes. this might be bad for you."`
}

func (args) Version() string {
	return "go-mod-clean " + VERSION + "    Built on " + BUILDTIME
}

func (a args) Description() string {
	return `
go-mod-clean will try to verify your go.* files are using the newest package versions

* Recreate go.* with 'go mod init' and 'go mod tidy'
* Set your required go in go.mod (default is go1.21
* Check that the most recent master branch versions are used
* Try to trim go.sum of non-existent entries
`
}
